Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TiXmlNode Class Reference

`#include <tinyxml.h>`

Inheritance diagram for TiXmlNode:

[legend]
Collaboration diagram for TiXmlNode:

[legend]
List of all members.

## Public Types
enum | NodeType { DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, DECLARATION, TYPECOUNT }
## Public Member Functions
virtual | ~TiXmlNode ()
const char * | Value () const
void | SetValue (const char *_value)
void | Clear ()
| Delete all the children of this node. Does not affect 'this'.
TiXmlNode * | Parent () const
| One step up the DOM.
TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'. Will be null if none found.
TiXmlNode * | LastChild () const
TiXmlNode * | LastChild (const char *value) const
| The last child of this node. Will be null if there are no children.
TiXmlNode * | IterateChildren (TiXmlNode *previous) const
| The last child of this node matching 'value'. Will be null if there are no children.
TiXmlNode * | IterateChildren (const char *value, TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'.
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | LinkAfterChild (TiXmlNode *afterThis, TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node.
TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node.
TiXmlNode * | NextSibling () const
| Navigate to a sibling node.
TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'.
TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const char *value) const
| Convenience function to get through elements.
virtual int | Type () const
TiXmlDocument * | GetDocument () const
bool | NoChildren () const
| Returns true if this node has no children.
TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlText * | ToText () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null not of the requested type.
virtual TiXmlNode * | Clone () const=0
void | SetUserData (void *user)
void * | GetUserData ()
## Protected Member Functions
| TiXmlNode (NodeType type)
TiXmlNode * | Identify (const char *start)
void | CopyToClone (TiXmlNode *target) const
TiXmlString | SValue () const
## Protected Attributes
TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TiXmlString | value
TiXmlNode * | prev
TiXmlNode * | next
void * | userData
## Friends
class | TiXmlDocument
class | TiXmlElement
TiXmlOutStream & | operator<< (TiXmlOutStream &out, const TiXmlNode &base)

## Detailed Description

The parent class for everything in the Document Object Model. (Except for attributes). Nodes have siblings, a parent, and children. A node can be in a document, or stand on its own. The type of a TiXmlNode can be queried, and it can be cast to its more defined type.

## Member Enumeration Documentation

enum TiXmlNode::NodeType

  | The types of XML nodes supported by TinyXml. (All the unsupported types are picked up by UNKNOWN.) Enumeration values:
  DOCUMENT |
  ELEMENT |
  COMMENT |
  UNKNOWN |
  TEXT |
  DECLARATION |
  TYPECOUNT |

## Constructor & Destructor Documentation

TiXmlNode::~TiXmlNode | ( |  | ) | `[virtual]`

TiXmlNode::TiXmlNode | ( | NodeType | type | ) | `[protected]`

## Member Function Documentation

void TiXmlNode::Clear | ( |  | ) |

| Delete all the children of this node. Does not affect 'this'.

virtual TiXmlNode* TiXmlNode::Clone | ( |  | ) | const`[pure virtual]`

| Implemented in TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

void TiXmlNode::CopyToClone | ( | TiXmlNode * | target | ) | const`[inline, protected]`

TiXmlNode * TiXmlNode::FirstChild | ( | const char * | value | ) | const

| The first child of this node with the matching 'value'. Will be null if none found.

TiXmlNode* TiXmlNode::FirstChild | ( |  | ) | const`[inline]`

| The first child of this node. Will be null if there are no children.

TiXmlElement * TiXmlNode::FirstChildElement | ( | const char * | value | ) | const

| Convenience function to get through elements.

TiXmlElement * TiXmlNode::FirstChildElement | ( |  | ) | const

| Convenience function to get through elements.

TiXmlDocument * TiXmlNode::GetDocument | ( |  | ) | const

| Return a pointer to the Document this node lives in. Returns null if not in a document.

void* TiXmlNode::GetUserData | ( |  | ) | `[inline]`

TiXmlNode * TiXmlNode::Identify | ( | const char * | start | ) | `[protected]`

TiXmlNode * TiXmlNode::InsertAfterChild | ( | TiXmlNode * | afterThis,
|  | const TiXmlNode & | addThis
| ) |

| Add a new node related to this. Adds a child after the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * TiXmlNode::InsertBeforeChild | ( | TiXmlNode * | beforeThis,
|  | const TiXmlNode & | addThis
| ) |

| Add a new node related to this. Adds a child before the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * TiXmlNode::InsertEndChild | ( | const TiXmlNode & | addThis | ) |

| Add a new node related to this. Adds a child past the LastChild. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * TiXmlNode::IterateChildren | ( | const char * | value,
|  | TiXmlNode * | previous
| ) | const

| This flavor of IterateChildren searches for children with a particular 'value'.

TiXmlNode * TiXmlNode::IterateChildren | ( | TiXmlNode * | previous | ) | const

| The last child of this node matching 'value'. Will be null if there are no children. An alternate way to walk the children of a node. One way to iterate over nodes is:
    			for( child = parent->FirstChild(); child; child = child->NextSibling() )
IterateChildren does the same thing with the syntax:
    			child = 0;
    			while( child = parent->IterateChildren( child ) )
IterateChildren takes the previous child as input and finds the next one. If the previous child is null, it returns the first. IterateChildren will return null when done.

TiXmlNode * TiXmlNode::LastChild | ( | const char * | value | ) | const

| The last child of this node. Will be null if there are no children.

TiXmlNode* TiXmlNode::LastChild | ( |  | ) | const`[inline]`

TiXmlNode * TiXmlNode::LinkAfterChild | ( | TiXmlNode * | afterThis,
|  | TiXmlNode * | addThis
| ) |

TiXmlNode * TiXmlNode::LinkEndChild | ( | TiXmlNode * | addThis | ) |

| Add a new node related to this. Adds a child past the LastChild. NOTE: the node to be added is passed by pointer, and will be henceforth owned (and deleted) by tinyXml. This method is efficient and avoids an extra copy, but should be used with care as it uses a different memory model than the other insert functions. See also: InsertEndChild

TiXmlNode * TiXmlNode::NextSibling | ( | const char * |  | ) | const

| Navigate to a sibling node with the given 'value'.

TiXmlNode* TiXmlNode::NextSibling | ( |  | ) | const`[inline]`

| Navigate to a sibling node.

TiXmlElement * TiXmlNode::NextSiblingElement | ( | const char * |  | ) | const

| Convenience function to get through elements. Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

TiXmlElement * TiXmlNode::NextSiblingElement | ( |  | ) | const

| Convenience function to get through elements. Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

bool TiXmlNode::NoChildren | ( |  | ) | const`[inline]`

| Returns true if this node has no children.

TiXmlNode* TiXmlNode::Parent | ( |  | ) | const`[inline]`

| One step up the DOM.

TiXmlNode * TiXmlNode::PreviousSibling | ( | const char * |  | ) | const

| Navigate to a sibling node.

TiXmlNode* TiXmlNode::PreviousSibling | ( |  | ) | const`[inline]`

| Navigate to a sibling node.

bool TiXmlNode::RemoveChild | ( | TiXmlNode * | removeThis | ) |

| Delete a child of this node.

TiXmlNode * TiXmlNode::ReplaceChild | ( | TiXmlNode * | replaceThis,
|  | const TiXmlNode & | withThis
| ) |

| Replace a child of this node. Returns a pointer to the new object or NULL if an error occured.

void TiXmlNode::SetUserData | ( | void * | user | ) | `[inline]`

void TiXmlNode::SetValue | ( | const char * | _value | ) | `[inline]`

| Changes the value of the node. Defined as:
    		Document:	filename of the xml file
    		Element:	name of the element
    		Comment:	the comment text
    		Unknown:	the tag contents
    		Text:		the text string

TiXmlString TiXmlNode::SValue | ( |  | ) | const`[inline, protected]`

TiXmlComment* TiXmlNode::ToComment | ( |  | ) | const`[inline]`

| Cast to a more defined type. Will return null not of the requested type.

TiXmlDeclaration* TiXmlNode::ToDeclaration | ( |  | ) | const`[inline]`

| Cast to a more defined type. Will return null not of the requested type.

TiXmlDocument* TiXmlNode::ToDocument | ( |  | ) | const`[inline]`

| Cast to a more defined type. Will return null not of the requested type.

TiXmlElement* TiXmlNode::ToElement | ( |  | ) | const`[inline]`

| Cast to a more defined type. Will return null not of the requested type.

TiXmlText* TiXmlNode::ToText | ( |  | ) | const`[inline]`

| Cast to a more defined type. Will return null not of the requested type.

TiXmlUnknown* TiXmlNode::ToUnknown | ( |  | ) | const`[inline]`

| Cast to a more defined type. Will return null not of the requested type.

virtual int TiXmlNode::Type | ( |  | ) | const`[inline, virtual]`

| Query the type (as an enumerated value, above) of this node. The possible types are: DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, and DECLARATION.

const char* TiXmlNode::Value | ( |  | ) | const`[inline]`

| The meaning of 'value' changes for the specific type of TiXmlNode.
    		Document:	filename of the xml file
    		Element:	name of the element
    		Comment:	the comment text
    		Unknown:	the tag contents
    		Text:		the text string
The subclasses will wrap this function.

## Friends And Related Function Documentation

TiXmlOutStream& operator<< | ( | TiXmlOutStream & | out,
|  | const TiXmlNode & | base
| ) | `[friend]`

friend class TiXmlDocument`[friend]`

| Reimplemented from TiXmlBase.

friend class TiXmlElement`[friend]`

| Reimplemented from TiXmlBase. Reimplemented in TiXmlText.

## Member Data Documentation

TiXmlNode* TiXmlNode::firstChild`[protected]`

TiXmlNode* TiXmlNode::lastChild`[protected]`

TiXmlNode* TiXmlNode::next`[protected]`

TiXmlNode* TiXmlNode::parent`[protected]`

TiXmlNode* TiXmlNode::prev`[protected]`

NodeType TiXmlNode::type`[protected]`

void* TiXmlNode::userData`[protected]`

TiXmlString TiXmlNode::value`[protected]`

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp
- tinyxmlparser.cpp